#version 330 core

in vec2 UV;


out vec4 color;

uniform sampler2D colorTexture;


float gauss (float x, float dev)
{
	return (1.0 / sqrt(2.0 * 3.141592 * dev)) * exp(-((x * x) / (2.0 * dev)));	
}

vec4 getColor(vec2 pos) {
	vec3 c = texture2D( colorTexture, pos ).rgb;
	if ((c.r + c.g) <= 1.5f) {
		return vec4(0,0,0,0);
	}else {
		//color = vec4(c, (c.r +c.g)/2);
		//color = vec4(1,1,1,1);
		return vec4(1,1,1,1);
	}
}

float getBrightness(vec3 c) {
	//return 0.2126*c.r + 0.7152*c.g + 0.0722*c.b;
	return (c.r + c.g + c.b)/3;
}

void main(){

	vec2 TexelSize = vec2(0.005,0.005);

	float BlurAmount = 10;
	int Orientation = 1;
	float BlurScale = 2.0;
	float BlurStrength = 2.0;
	
	float halfBlur = float(BlurAmount) * 0.5;
	vec4 col = vec4(0.0);
	vec4 texCol = vec4(0.0);
	
	// Gaussian deviation
	float dev = halfBlur * 0.35;
	dev *= dev;
	float strength = 1.0 - BlurStrength;
	
	//if ( Orientation == 0 )
	//{
		// Horizontal blur
		for (int i = 0; i < 10; ++i)
		{
			if ( i >= BlurAmount )
				break;
			
			float offset = float(i) - halfBlur;
			texCol = (getColor( UV + vec2(offset * TexelSize.x * BlurScale, 0.0)) * gauss(offset * strength, dev))/2;
			col += texCol;
		}
	//}
	//else
	//{
		// Vertical blur
		for (int i = 0; i < 10; ++i)
		{
			if ( i >= BlurAmount )
				break;
			
			float offset = float(i) - halfBlur;
			texCol = (getColor( UV + vec2(0.0, offset * TexelSize.y * BlurScale)) * gauss(offset * strength, dev))/2;
			col += texCol;
		}
	//}
	
	// Apply colour
	color = vec4(clamp(col, 0.0, 1.0)); //,getBrightness(col));

}