#version 330 core

layout(location = 0) in vec3 vertices;

out vec2 UV;

uniform vec3 camRight_world;
uniform vec3 camUp_world;
uniform mat4 VPmat;
uniform vec3 sunPos; // Position of the center of the billboard
uniform vec2 sunSize; // Size of the billboard, in world units

void main()
{
	vec3 particleCenter_world = sunPos;

	vec3 vertexPos_world = particleCenter_world + camRight_world * vertices.x * sunSize.x + camUp_world * vertices.y * sunSize.y;

	// Output position of the vertex
	gl_Position = VPmat * vec4(vertexPos_world, 1.0f);

	UV = vertices.xy + vec2(0.5, 0.5);
}

